'' Fractal Audio Visualizer Demo for DEMOboard (previously Hydra) 
'' Simluation of precursor to 1980's numeric sound and voice synthesizer
' AUTHOR: William Como / Virand
' LAST MODIFIED: 08/16/09 ; 12.30.07
' VERSION 1.01

'' Requires: ****************************************
'' TV_DRV_010
'' GRAPHICS_DRV_010

CON

  _clkmode = xtal1 + pll16x            ' enable external clock and pll times 8
  _xinfreq = 5_000_000               ' set frequency to 10 MHZ
  _stack = ($3000 + $3000 + 64) >> 2  'accomodate display memory and stack
  ' graphics screen constants
  PARAMCOUNT        = 14        
  OFFSCREEN_BUFFER  = $2000           ' offscreen buffer
  ONSCREEN_BUFFER   = $5000           ' onscreen buffer
  ' size of graphics tile map
  X_TILES           = 16
  Y_TILES           = 12
  ' size of graphics pixel map
  SCREEN_WIDTH      = 256
  SCREEN_HEIGHT     = 192 

VAR
  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[X_TILES * Y_TILES] ' storage for screen tile map
  long  colors[64]
  word  timesdrawn                ' color look up table

OBJ
  tv    : "tv_drv_010.spin"          ' tv object
  gr    : "graphics_drv_010.spin"    ' graphics object


PUB start | i, a, dx, dy, color

  'start tv
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)

  'Colors
  repeat i from 0 to 64
    colors[i] := $CB1B7E7C 'TRS-80 CoCo Colorset  'override:
    colors[i] := $052A052A 'Atari 800 (choice)

  'setup screen tiles
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := onscreen_buffer >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)

  'start and setup graphics 256x192
  gr.start
  gr.setup(X_TILES, Y_TILES, 0, 0, onscreen_buffer)
  'sound on
  dira[7]:=1
  
  ' DRAW SEED PATTERN (This is a huge virtual PRNG)
  ' Randomness should only look and sound like tube TV static

  a:=0
  gr.clear
  gr.color(1)
  gr.plot(0,0)
  gr.line(255,191)
  gr.plot(0,191)
  gr.line(255,0)

  'MAIN LOOP
  
  repeat
   repeat i from $5000 to $7FFF 'try $67FF
    'graphic magic
    a:=a^byte[i]
    byte[i]:=a
    'sound magic
    outa[7]:=a&1


DAT
tvparams                long    0               'status
                        long    1               'enable
                        long    58*0+%10101 '%011_0000  'pins (58 was hydra)
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx timing stretch
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    55_250_000      'broadcast on channel 2 VHF, each channel is 6 MHz above the previous
                        long    0               'auralcog

                                                 